From oracle-l-bounce@freelists.org  Tue Jul 20 09:47:28 2004
Return-Path: <oracle-l-bounce@freelists.org>
Received: from air189.startdedicated.com (root@localhost)
 by orafaq.com (8.11.6/8.11.6) with ESMTP id i6KElC303612
 for <oracle-l@orafaq.com>; Tue, 20 Jul 2004 09:47:22 -0500
X-ClientAddr: 206.53.239.180
Received: from turing.freelists.org (freelists-180.iquest.net [206.53.239.180])
 by air189.startdedicated.com (8.11.6/8.11.6) with ESMTP id i6KEl0603412
 for <oracle-l@orafaq.com>; Tue, 20 Jul 2004 09:47:10 -0500
Received: from localhost (localhost [127.0.0.1])
 by turing.freelists.org (Avenir Technologies Mail Multiplex) with ESMTP
 id 9B41F72CD49; Tue, 20 Jul 2004 09:26:26 -0500 (EST)
Received: from turing.freelists.org ([127.0.0.1])
 by localhost (turing [127.0.0.1]) (amavisd-new, port 10024) with ESMTP
 id 25458-64; Tue, 20 Jul 2004 09:26:26 -0500 (EST)
Received: from turing (localhost [127.0.0.1])
 by turing.freelists.org (Avenir Technologies Mail Multiplex) with ESMTP
 id 0D42C72CD93; Tue, 20 Jul 2004 09:26:24 -0500 (EST)
Received: with ECARTIS (v1.0.0; list oracle-l); Tue, 20 Jul 2004 09:24:53 -0500 (EST)
X-Original-To: oracle-l@freelists.org
Delivered-To: oracle-l@freelists.org
Received: from localhost (localhost [127.0.0.1])
 by turing.freelists.org (Avenir Technologies Mail Multiplex) with ESMTP id 19E4672C4ED
 for <oracle-l@freelists.org>; Tue, 20 Jul 2004 09:24:53 -0500 (EST)
Received: from turing.freelists.org ([127.0.0.1])
 by localhost (turing [127.0.0.1]) (amavisd-new, port 10024) with ESMTP
 id 25447-26 for <oracle-l@freelists.org>;
 Tue, 20 Jul 2004 09:24:52 -0500 (EST)
Received: from MXR-5.estpak.ee (ld3.estpak.ee [194.126.101.102])
 by turing.freelists.org (Avenir Technologies Mail Multiplex) with ESMTP id B2B6F72C4A2
 for <oracle-l@freelists.org>; Tue, 20 Jul 2004 09:24:52 -0500 (EST)
Received: from porgand (217-159-135-212-dsl.kvm.estpak.ee [217.159.135.212])
 by MXR-5.estpak.ee (Postfix) with SMTP id EF63D45FC2
 for <oracle-l@freelists.org>; Tue, 20 Jul 2004 17:50:42 +0300 (EEST)
Message-ID: <30ee01c46e68$ee2a4be0$0a879fd9@porgand>
From: =?ISO-8859-1?Q?Tanel_P=F5der?= <tanel.poder.003@mail.ee>
To: <oracle-l@freelists.org>
References: <974B0BC4C9F3BB40B2651F8FC12B7B98A52189@emss04m12.us.lmco.com>
Subject: Re: No stats, why the heck is CBO running???
Date: Tue, 20 Jul 2004 17:50:41 +0300
MIME-Version: 1.0
Content-type: text/plain; charset=ISO-8859-1
Content-Transfer-Encoding: 8bit
X-Priority: 3
X-MSMail-Priority: Normal
X-Mailer: Microsoft Outlook Express 6.00.2800.1437
X-MimeOLE: Produced By Microsoft MimeOLE V6.00.2800.1441
X-Virus-Scanned: by amavisd-new-20030616-p7 (Debian) at neti.ee
X-Virus-Scanned: by amavisd-new at freelists.org
X-archive-position: 5498
X-ecartis-version: Ecartis v1.0.0
Sender: oracle-l-bounce@freelists.org
Errors-To: oracle-l-bounce@freelists.org
X-original-sender: tanel.poder.003@mail.ee
Precedence: normal
Reply-To: oracle-l@freelists.org
X-list: oracle-l
X-Virus-Scanned: by amavisd-new at freelists.org

> Yet a simple query to find the "next extext that wont fit" is always using
the CBO???
>
> This SQL queries DBA_TABLES and DBA_FREE_SPACE.  There are NO hints in the
SQL.
>
> What the heck?

But there are hints in DBA_FREE_SPACE:

SQL> select text from dba_views where view_name = 'DBA_FREE_SPACE';

TEXT
----------------------------------------------------------------------------
----
select ts.name, fi.file#, f.block#,
       f.length * ts.blocksize, f.length, f.file#
from sys.ts$ ts, sys.fet$ f, sys.file$ fi
where ts.ts# = f.ts#
  and f.ts# = fi.ts#
  and f.file# = fi.relfile#
  and ts.bitmapped = 0
union all
select /*+ ordered use_nl(f) use_nl(fi) */
       ts.name, fi.file#, f.ktfbfebno,
       f.ktfbfeblks * ts.blocksize, f.ktfbfeblks, f.ktfbfefno
from sys.ts$ ts, sys.x$ktfbfe f, sys.file$ fi
where ts.ts# = f.ktfbfetsn
  and f.ktfbfetsn = fi.ts#
  and f.ktfbfefno = fi.relfile#
  and ts.bitmapped <> 0 and ts.online$ in (1,4) and ts.contents$ = 0

These kind of issues are one of the reasons why one should avoid putting
hints inside views...

Now, when you join several unanalyzed tables with one analyzed one, CBO will
be used by default and default statistics will be used for unanalyzed tables
(or dynamic sampling depending on optimizer_dynamic_sampling parameter).

Tanel.


----------------------------------------------------------------
Please see the official ORACLE-L FAQ: http://www.orafaq.com
----------------------------------------------------------------
To unsubscribe send email to:  oracle-l-request@freelists.org
put 'unsubscribe' in the subject line.
--
Archives are at http://www.freelists.org/archives/oracle-l/
FAQ is at http://www.freelists.org/help/fom-serve/cache/1.html
-----------------------------------------------------------------

